/**
  @page DAC_DualConversion DAC Dual Conversion example
  
  @verbatim
  ********************* COPYRIGHT(c) 2017 STMicroelectronics *******************
  * @file    DAC/DAC_DualConversion/readme.txt 
  * @author  MCD Application Team
  * @brief   Description of the DAC Dual Conversion example.
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2017 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  @endverbatim

@par Example Description 

This example provides a short description of how to use the DAC peripheral in a dual conversion.

At the beginning of the main program the HAL_Init() function is called to reset 
all the peripherals, initialize the Flash interface and the systick.
The SystemClock_Config() function is used to configure the system clock for STM32H743xx Devices :
- The CPU at 400MHz 
- The HCLK for D1 Domain AXI and AHB3 peripherals , D2 Domain AHB1/AHB2 peripherals and D3 Domain AHB4  peripherals at 200MHz.
- The APB clock dividers for D1 Domain APB3 peripherals, D2 Domain APB1 and APB2 peripherals and D3 Domain APB4 peripherals to  run at 100MHz

Test description
------------------

The example uses the DAC for a dual conversion in 12 bits right alignment, the result of 
conversion can be seen by connecting PA4(DAC channel1) and PA5(DAC channel2) to an oscilloscope. 

Each time the tamper is pressed the waves generated by both channels change between
noise and triangle signals.

STM32H743I-EVAL board's LEDs can be used to monitor the process status:
  - LED4 is ON and example is stopped (using infinite loop)
  when there is an error during process.
  
@note In order to observe signal on channel2(PA5), R118 should be removed.
      
@note LED3 is ON during test because it is connected to PA4 (DAC channel1).


@note Care must be taken when using HAL_Delay(), this function provides accurate delay (in milliseconds)
      based on variable incremented in SysTick ISR. This implies that if HAL_Delay() is called from
      a peripheral ISR process, then the SysTick interrupt must have higher priority (numerically lower)
      than the peripheral interrupt. Otherwise the caller ISR process will be blocked.
      To change the SysTick interrupt priority you have to use HAL_NVIC_SetPriority() function.
      
@note The example need to ensure that the SysTick time base is always set to 1 millisecond
      to have correct HAL operation.

@Note If the  application is using the DTCM/ITCM memories (@0x20000000/ 0x0000000: not cacheable and only accessible
      by the Cortex M7 and the  MDMA), no need for cache maintenance when the Cortex M7 and the MDMA access these RAMs.
      If the application needs to use DMA(or other masters) based access or requires more RAM, then  the user has to:
              - Use a non TCM SRAM. (example : D1 AXI-SRAM @ 0x24000000)
              - Add a cache maintenance mechanism to ensure the cache coherence between CPU and other masters(DMAs,DMA2D,LTDC,MDMA).
              - The addresses and the size of cacheable buffers (shared between CPU and other masters)
                must be	properly defined to be aligned to L1-CACHE line size (32 bytes). 
 
@Note It is recommended to enable the cache and maintain its coherence.
      Depending on the use case it is also possible to configure the cache attributes using the MPU.
      Please refer to the AN4838 "Managing memory protection unit (MPU) in STM32 MCUs"
      Please refer to the AN4839 "Level 1 cache on STM32F7 Series"

@par Directory contents 

  - DAC/DAC_DualConversion/Inc/stm32h7xx_hal_conf.h    HAL configuration file
  - DAC/DAC_DualConversion/Inc/stm32h7xx_it.h          Header for stm32h7xx_it.c
  - DAC/DAC_DualConversion/Inc/main.h                  Header for main.c  
  - DAC/DAC_DualConversion/Src/stm32h7xx_it.c          Interrupt handlers
  - DAC/DAC_DualConversion/Src/main.c                  Main program
  - DAC/DAC_DualConversion/Src/stm32h7xx_hal_msp.c     HAL MSP module
  - DAC/DAC_DualConversion/Src/system_stm32h7xx.c      STM32H7xx system clock configuration file
  

@par Hardware and Software environment

  - This example runs on STM32H743xx devices.
    
  - This example has been tested with STM32H743I-EVAL board and can be
    easily tailored to any other supported device and development board.

  - STM32H743I-EVAL Set-up 	
      
      - Remove R118 to observe signal on PA5.
      - Connect PA4 (DAC Channel1: pin 19 in CN6) and PA5 (DAC Channel2: pin 22 in CN6) to an oscilloscope.	  
      - Press tamper button to switch between wave signal generation.
       
     
@par How to use it ? 

In order to make the program work, you must do the following :
 - Open your preferred toolchain 
 - Rebuild all files and load your image into target memory
 - Run the example
  
 * <h3><center>&copy; COPYRIGHT STMicroelectronics</center></h3>
 */

